import { FunctionInitFunction } from '../main/functionInit/functionInitEngine';
/**
 * With this function, you can prepare and initialize a function.
 * Usually, it is used to prepare stuff only once for
 * callback functions in the zation configs.
 * @example
 * $init((bag) => {
 *    //prepare stuff
 *    const db = bag.databox(ProfileDataboxV1);
 *    return (bag,socket) => {
 *        //the callback
 *    }
 * })
 * @param initFunction
 */
export declare function $init<T>(initFunction: FunctionInitFunction<T>): T;
