/**
 * @description
 * The Starter decorator can be used to mark a method as a starter.
 * All starter methods will be called after all initializers have been called and
 * all components have been initialized.
 * Notice that starter methods can not access the this-context.
 * The only exception is when you use the starter decorator on a non-static
 * method of a singleton class, then the this-context refers to the singleton instance.
 * @param target
 * @param propertyKey
 * @param descriptor
 * @example
 *   @Starter
 *   static async start() {
 *      //do some stuff
 *   }
 */
export default function Starter(target: any, propertyKey: string, descriptor: PropertyDescriptor): void;
