import { CudOperation } from '../../main/databox/dbDefinitions';
import Socket from '../Socket';
import { DeepReadonly } from '../../main/utils/typeUtils';
export interface Transaction {
    operations: DeepReadonly<CudOperation[]>;
    code?: string | number;
    metadata?: any;
}
export interface SignalAction {
    signal: string;
    data?: any;
    /**
     * @description
     * Will change the data of this signal action for this socket.
     */
    changeData: (newData: any) => void;
}
export interface FetchRequest {
    counter: number;
    input?: any;
    /**
     * @description
     * Indicates if this fetch is a reload fetch.
     */
    reload: boolean;
}
export interface StaticDbInConnection {
    readonly socket: Socket;
    readonly options?: any;
    /**
     * @description
     * Timestamp that indicates the creation time of the connection.
     */
    readonly created: number;
}
export interface DbInConnection<M = string> extends StaticDbInConnection {
    /**
     * Notice that the member is deep readonly.
     */
    readonly member: DeepReadonly<M>;
}
