import { DefinitionModel } from '../../main/models/definitionModel';
/**
 * @description
 * This function helps you to create several models.
 * The key of each pair will be used as a model name.
 * The names will help you to identify the models in case of errors easier.
 * @param models
 * @example
 * const formModels = $models({
 *    name: {
 *        type: 'string'
 *    },
 *
 *    age: {
 *        type: 'int',
 *        minValue: 18
 *    }
 * });
 */
export declare function $models<T extends Record<string, DefinitionModel>>(models: T): T;
