import Bag from "../../api/Bag";
import { ApiLevelSwitch } from '../apiLevel/apiLevelUtils';
import ChannelCore from '../../api/channel/ChannelCore';
import { AnyChannelClass } from '../../api/channel/AnyChannelClass';
import { ChannelConfig } from '../config/definitions/parts/channelConfig';
import ComponentPrepare from '../component/componentPrepare';
import ConfigProvider from '../config/management/configProvider';
export declare class ChannelPrepare extends ComponentPrepare<ChannelCore, ChannelConfig> {
    constructor(cp: ConfigProvider, bag: Bag);
    protected createIncompatibleAPILevelError(): Error;
    protected createComponentNotExistsError(identifier: string): Error;
    /**
     * Prepare a Channel.
     * @param identifier
     * @param definition
     */
    protected _prepare(identifier: string, definition: AnyChannelClass | ApiLevelSwitch<AnyChannelClass>): void;
    /**
     * Process a Channel and create the prepared data.
     * @param channel
     * @param identifier
     * @param apiLevel
     */
    private processChannel;
}
