import Component, { ComponentClass } from '../../api/component/Component';
import ComponentPrepare from './componentPrepare';
export declare const componentSymbol: unique symbol;
export declare const componentTypeSymbol: unique symbol;
export declare const staticComponentSymbol: unique symbol;
export declare const endpointNameSymbol: unique symbol;
export declare const apiLevelSymbol: unique symbol;
export default class ComponentUtils {
    static getComponentType(component: Component): string;
    static isStaticComponent(component: ComponentClass | Component): boolean;
    static extractAPIInfo(component: ComponentClass): {
        endpointName: string;
        apiLevel?: number;
    };
    /**
     * @description
     * Parses the API level and endpoint name from a component class name.
     * @param name
     */
    static parseClassName(name: string): {
        name: string;
        apiLevel?: number;
    };
    /**
     * Checks the component endpoint name.
     * @param name
     */
    static checkEndpointName(name: string): void;
    /**
     * Returns the component endpoint name from the identifier.
     * @param identifier
     */
    static extractEndpointName(identifier: string): string;
    static buildTreeInfoStructure(includeSystemComp: boolean, ...compPrepares: ComponentPrepare<any, any>[]): {};
}
