import { AppConfig } from './appConfig';
import { InternalServerConfig, ServerConfig } from './serverConfig';
import { ServicesConfig } from './servicesConfig';
import { ServerState } from '../../../../api/ServerState';
export declare type ConfigurationBuilder<T> = (serverState: ServerState) => T | Promise<T>;
export declare type ConfigurationDefinition<T> = ConfigurationBuilder<T> | T;
export default interface Configurations {
    server?: ConfigurationDefinition<ServerConfig>;
    app?: ConfigurationDefinition<AppConfig>;
    services?: ConfigurationDefinition<ServicesConfig>;
}
export interface InternalConfigurations {
    server: InternalServerConfig;
    app: AppConfig;
    services: ServicesConfig;
}
