import { ConfigurationBuilder } from '../definitions/main/configurations';
export declare type ConfigurationWrapper<T> = ConfigurationBuilder<T> & {
    /**
     * Registers the configuration.
     * @param merge
     * Defines if the configuration should be merged with
     * already registered configurations of the same type.
     * This means existing primitive properties will
     * be overridden and new properties added.
     * When this option is deactivated (default),
     * and a configuration is already registered,
     * a ConfigBuildError will be thrown.
     */
    register: (merge?: boolean) => void;
};
