import Bag from "../../api/Bag";
import { ApiLevelSwitch } from "../apiLevel/apiLevelUtils";
import DataboxCore from "../../api/databox/DataboxCore";
import { DataboxConfig } from '../config/definitions/parts/databoxConfig';
import { AnyDataboxClass } from '../../api/databox/AnyDataboxClass';
import ComponentPrepare from '../component/componentPrepare';
import ConfigProvider from '../config/management/configProvider';
export default class DataboxPrepare extends ComponentPrepare<DataboxCore, DataboxConfig> {
    constructor(cp: ConfigProvider, bag: Bag);
    protected createIncompatibleAPILevelError(): Error;
    protected createComponentNotExistsError(identifier: string): Error;
    /**
     * Prepare a Databox.
     * @param identifier
     * @param definition
     */
    protected _prepare(identifier: string, definition: AnyDataboxClass | ApiLevelSwitch<AnyDataboxClass>): void;
    /**
     * Process a Databox and create the prepared data.
     * @param databox
     * @param identifier
     * @param apiLevel
     */
    private processDatabox;
}
