import Bag from '../../api/Bag';
export declare type FunctionInitFunction<T> = (bag: Bag) => Promise<T> | T;
export default class FunctionInitEngine {
    private static readonly initTask;
    /**
     * Create a new init function and
     * add it to the initialize process.
     * @param initFunction
     */
    static initFunction<T extends (...args: any) => any>(initFunction: FunctionInitFunction<T>): T;
    /**
     * Initialize all init functions.
     * @param bag
     */
    static initFunctions(bag: Bag): Promise<void>;
}
