import { ObjectEditOperation } from '../definitions/objectEditOperation';
import { IsStrictlyAny } from '../utils/typeUtils';
import { DeepRequired } from 'ts-essentials';
interface CommitFunction {
    /**
     * @description
     * Applies all changes.
     */
    commit(): void | Promise<void>;
}
interface ClearFunction {
    /**
     * @description
     * Clears the root value to an empty object.
     */
    clear(): void;
}
export declare type PathEditContentBundle<T> = ({} extends T ? ClearFunction : {}) & CommitFunction & (IsStrictlyAny<T> extends true ? {
    [K: string]: any;
} : DeepRequired<T>);
export declare type PathEditContent<T> = ({} extends T ? ClearFunction : {}) & (IsStrictlyAny<T> extends true ? {
    [K: string]: any;
} : DeepRequired<T>);
export default function createPathEditContentAPI<T, B extends boolean | undefined>(onCommit: (operations: ObjectEditOperation[]) => void | Promise<void>, bundle?: B): true extends B ? PathEditContentBundle<T> : PathEditContent<T>;
export {};
