import { AuthToken } from "../definitions/internal";
import { DeepReadonly } from 'ts-essentials';
export default class ZationToken<TP extends object = any> {
    private readonly _token;
    constructor(token: AuthToken);
    get userId(): number | string | undefined;
    get authUserGroup(): string | undefined;
    get tokenId(): string;
    get expire(): number;
    get panelAccess(): boolean;
    get rawToken(): AuthToken;
    /**
     * Returns the token payload.
     */
    getTokenPayload(): DeepReadonly<Partial<TP>>;
    /**
     * Returns a deep clone of the token payload.
     */
    getTokenPayloadClone(): Partial<TP>;
}
