export declare const enum Color {
    Black = 0,
    Red = 1,
    Green = 2,
    Yellow = 3,
    Blue = 4,
    Magenta = 5,
    Cyan = 6,
    White = 7
}
export interface LogCategory {
    /**
     * Name of the log category.
     * Will be displayed in the log message.
     */
    name: string;
    /**
     * Log level of the category.
     */
    level: number;
    /**
     * Color of the category.
     */
    color?: Color;
}
export declare const defaultLogCategories: {
    debug: LogCategory;
    launchDebug: LogCategory;
    info: LogCategory;
    success: LogCategory;
    busy: LogCategory;
    warn: LogCategory;
    error: LogCategory;
    failed: LogCategory;
    fatal: LogCategory;
    active: LogCategory;
};
