import { LogCategory } from './logCategories';
import { FileLogOptions, PanelLogOptions } from '../config/definitions/main/serverConfig';
import ZationServer from "../../core/ZationServer";
export interface LogWriter {
    write(msg: string, category: LogCategory): void;
}
export declare function createConsoleLogWriter(logLevel: number): LogWriter;
export declare const logFileFileName = "ZATION_LOG_FILE.log";
export declare function processFileLogPath(fileLogOptions: Required<FileLogOptions>, rootPath: string): string;
export declare function createFileLogWriter(fileLogOptions: Required<FileLogOptions>, rootPath: string): LogWriter;
export declare function createPanelLogWriter(panelLogOptions: Required<PanelLogOptions>, server: ZationServer): LogWriter;
