import { LogWriter } from './logWriter';
import { LogCategory } from './logCategories';
export default interface SimpleLogger {
    /**
     * @description
     * Logging with a custom category.
     * @param args
     */
    custom: (category: LogCategory, ...args: any[]) => void;
    /**
     * @description
     * Logging with category: debug.
     * @param args
     */
    debug: (...args: any[]) => void;
    /**
     * @description
     * Logging with category: launch debug.
     * @param args
     */
    launchDebug: (...args: any[]) => void;
    /**
     * @description
     * Logging with category: information.
     * @param args
     */
    info: (...args: any[]) => void;
    /**
     * @description
     * Logging with category: success.
     * @param args
     */
    success: (...args: any[]) => void;
    /**
     * @description
     * Logging with category: busy.
     * @param args
     */
    busy: (...args: any[]) => void;
    /**
     * @description
     * Logging with category: warning.
     * @param args
     */
    warn: (...args: any[]) => void;
    /**
     * @description
     * Logging with category: error.
     * @param args
     */
    error: (...args: any[]) => void;
    /**
     * @description
     * Logging with category: failed.
     * @param args
     */
    failed: (...args: any[]) => void;
    /**
     * @description
     * Logging with category: fatal.
     * @param args
     */
    fatal: (...args: any[]) => void;
    /**
     * @description
     * Logging with category: active.
     * @param args
     */
    active: (...args: any[]) => void;
}
export declare const EmptySimpleLogger: SimpleLogger;
export declare function createSimpleLogger(writer: LogWriter[], launchDebug: boolean, debug: boolean): SimpleLogger;
