import { DefinitionModel } from './definitionModel';
export interface ModelMetaData {
    /**
     * Indicates if the inner model is optional.
     */
    optional?: boolean;
    /**
     * Indicates the default value when the data for the model
     * is not provided by the client.
     */
    default?: any;
    /**
     * Indicates if the inner model can be null.
     */
    canBeNull?: boolean;
}
export interface MetaModel<T extends DefinitionModel = {}> extends ModelMetaData {
    /**
     * The inner wrapped definition model.
     */
    definitionModel: T;
}
export declare function createMetaModel<T extends DefinitionModel = {}>(model: T): MetaModel<T>;
export declare function isMetaModel(value: any): value is MetaModel;
export declare function getModelMetaData<T extends DefinitionModel>(model: T): ModelMetaData;
export declare function isOptionalMetaModel(value: any): boolean;
export declare function addNewMetaToModel<T extends DefinitionModel>(model: T, meta: ModelMetaData): T extends DefinitionModel ? MetaModel<T> : T;
export declare function unwrapIfMetaModel<T extends object>(value: T): DefinitionModel;
