import { DirectModel, Model } from './model';
import { MetaModel } from './metaModel';
import { ReadStream } from 'ziron-worker';
import { ModelTranslatable, modelTranslateSymbol } from '../../api/configTranslatable/modelTranslatable';
import { AnyOfModel, DefinitionModel, ObjectModel, StreamModel, ValueModel } from './definitionModel';
import { ExtractNonStrictValidationType, ExtractStrictValidationType } from './validator/validationType';
declare type TypeofMultiValueType<T, ST extends boolean> = T extends string ? (ST extends true ? ExtractStrictValidationType<T> : ExtractNonStrictValidationType<T>) : never;
declare type TypeofValueType<T, ST extends boolean> = T extends string[] ? TypeofMultiValueType<T[keyof T], ST> : T extends string ? (ST extends true ? ExtractStrictValidationType<T> : ExtractNonStrictValidationType<T>) : any;
declare type TypeofValueTypes<T extends any[] | Record<string, any>> = T extends any[] ? T[number] : T[keyof T];
declare type TypeofAnyOfModelValue<T extends Model[] | Record<string, Model>> = {
    [key in keyof T]: T[key] extends Model ? TypeofModel<T[key]> : never;
};
declare type TypeofAnyOfModel<T extends AnyOfModel> = TypeofValueTypes<TypeofAnyOfModelValue<T['anyOf']>>;
declare type TypeofValueModel<T extends ValueModel> = T["convertType"] extends false ? T["strictType"] extends false ? TypeofValueType<T['type'], false> : TypeofValueType<T['type'], true> : TypeofValueType<T['type'], true>;
declare type TypeofObjectModel<T extends Record<string, Model>> = {
    [key in keyof T]: TypeofModel<T[key]>;
};
declare type TypeofArrayModel<T extends {
    "0": Model;
}> = (TypeofModel<T["0"]>)[];
declare type TypeofStreamModel<T extends StreamModel> = T['chunks'] extends string ? ReadStream<ArrayBuffer> : ReadStream<TypeofModel<Exclude<T['chunks'], string>>>;
declare type TypeofMetaModel<T extends MetaModel> = T['optional'] extends true ? T['canBeNull'] extends true ? undefined | null | TypeofDefinitionModel<T["definitionModel"]> : undefined | TypeofDefinitionModel<T["definitionModel"]> : T['canBeNull'] extends true ? null | TypeofDefinitionModel<T["definitionModel"]> : TypeofDefinitionModel<T["definitionModel"]>;
declare type TypeofDefinitionModel<T extends DefinitionModel> = T extends {
    "0": Model;
} ? TypeofArrayModel<T> : T extends ObjectModel ? TypeofObjectModel<T["properties"]> : T extends StreamModel ? TypeofStreamModel<T> : T extends ValueModel ? TypeofValueModel<T> : T extends AnyOfModel ? TypeofAnyOfModel<T> : any;
declare type TypeofDirectModel<T extends DirectModel> = T extends DefinitionModel ? TypeofDefinitionModel<T> : T extends MetaModel ? TypeofMetaModel<T> : any;
export declare type TypeofModel<T extends Model> = T extends DirectModel ? TypeofDirectModel<T> : T extends ModelTranslatable ? TypeofDirectModel<ReturnType<T[typeof modelTranslateSymbol]>> : T extends {
    new (): any;
    prototype: {};
} ? T["prototype"] : any;
export {};
