import BackErrorBag from "../../../api/BackErrorBag";
import { PreparedErrorData } from "./validatorCreator";
import { ValidationFunctions } from '../../config/definitions/parts/validationFunctions';
export declare type TypeValidator = (input: any) => boolean;
export declare type FunctionValidator = (input: any, backErrorBag: BackErrorBag, prepareErrorData: PreparedErrorData, type: string | undefined) => void | Promise<void>;
export declare namespace ValidatorLibrary {
    const Functions: Record<keyof ValidationFunctions, (settings: any) => FunctionValidator>;
    const Types: Record<"string" | "number" | "boolean" | "object" | "ascii" | "base64" | "binary" | "sha512" | "array" | "null" | "userId" | "char" | "int" | "float" | "date" | "email" | "sha256" | "sha384" | "sha1" | "md5" | "hexColor" | "hexadecimal" | "ip4" | "ip6" | "isbn10" | "isbn13" | "json" | "url" | "mimeType" | "macAddress" | "mobileNumber" | "uuid3" | "uuid4" | "uuid5" | "mongoId" | "latLong" | "stream", (strictType: boolean) => TypeValidator>;
}
