import { AuthUserGroupConfig } from "../config/definitions/parts/userGroupsConfig";
import PanelChannel from '../channel/systemChannels/channels/PanelChannel';
import ZationServer from '../../core/ZationServer';
export default class PanelEngine {
    readonly panelInUse: boolean;
    private panelInUseTimeout;
    private readonly server;
    private readonly coreServer;
    private readonly panelChannel;
    private readonly cp;
    private readonly panelUserMap;
    private readonly panelAccessData;
    private sentInit;
    constructor(server: ZationServer, panelChannel: PanelChannel, authUserGroups: Record<string, AuthUserGroupConfig>);
    private initPanelUserMap;
    private loadPanelAccessData;
    private addUser;
    private registerPanelInEvent;
    private registerClusterStateChangeEvents;
    private renewPanelInUse;
    sendUpdates(): void;
    sendLogMessage(message: object): void;
    private pubSelfState;
    private pubInternalServersState;
    private pubStateState;
    private pubBrokerState;
    private pubInPanel;
    isPanelLoginDataValid(username: string, password: string): Promise<boolean>;
    getPanelUserMap(): Record<string, string>;
    static loadAndAdjustPanelIndex(baseHref: string): string;
    static readonly staticPanelFilesPath: string;
}
