import { AnyClass } from './typeUtils';
export default class DynamicSingleton {
    static create<T extends {
        new (...args: any[]): I;
    }, I>(classDef: T & any, ...args: ConstructorParameters<T>): I;
    static getInstance<T extends {
        new (...args: any[]): I;
    }, I>(classDef: T & any): I | undefined;
    /**
     * This method loads the instance of the singleton and returns it.
     * If the instance is not found, the method throws an error.
     * @param classDef
     */
    static getInstanceSafe<T extends AnyClass>(classDef: T): T['prototype'];
}
