export declare type CleanupFunc = ((signal: string) => Promise<void> | void);
export declare class ExitEngine {
    static readonly instance: ExitEngine;
    private cleanupHandler;
    private exitPromises;
    private constructor();
    init(): void;
    addExitPromise(promise: Promise<any>): void;
    rmExitPromise(promise: Promise<any>): void;
    addCleanupHandler(func: CleanupFunc): void;
    rmCleanupHandler(func: CleanupFunc): void;
    private signalHandler;
    private static exceptionHandler;
    private exitHandler;
    private readonly sigintHandler;
    private readonly sighupHandler;
    private readonly sigquitHandler;
    private readonly sigtermHandler;
    private readonly boundExceptionHandler;
    private readonly boundExitHandler;
    private register;
    private unregister;
}
